


#include "HIVE_CppPlugin.h"


NS_HIVE_BEGIN


static std::string TrackingTypeToString(Analytics::TrackingType trackingType)
{
	if(trackingType == Analytics::TrackingType::ADJUST)
		return "ADJUST";
    else if(trackingType == Analytics::TrackingType::SINGULAR)
        return "SINGULAR";
	else
		return "UNKNOWN";
}


bool Analytics::sendAnalyticsLog(picojson::object & logData)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Analytics", "sendAnalyticsLog");
	jsonParam["logData"] = picojson::value(logData);

    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    bool bIsLogin = false;
    picojson::value jsonValue = resJson.get("sendAnalyticsLog");
    if(jsonValue.is<picojson::null>() == false)
        bIsLogin = jsonValue.evaluate_as_boolean();
    
    return bIsLogin;
}


void Analytics::setEnableTracker(TrackingType trackingType, bool isEnable)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Analytics", "setEnableTracker");

	jsonParam["trackingType"] = picojson::value(TrackingTypeToString(trackingType));
	jsonParam["isEnable"] = picojson::value(isEnable);

	HiveCppPlugin::callNative(jsonParam);
}


void Analytics::sendEvent(std::string eventName)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Analytics", "sendEvent");
	jsonParam["eventName"] = picojson::value(eventName);

	HiveCppPlugin::callNative(jsonParam);
}

void Analytics::sendUserEntryFunnelsLogs(std::string funnelTrack, std::string optionTag) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Analytics", "sendUserEntryFunnelsLogs");
    jsonParam["funnelTrack"] = picojson::value(funnelTrack);
    jsonParam["optionTag"] = picojson::value(optionTag);
    
    HiveCppPlugin::callNative(jsonParam);
}

unsigned int Analytics::getRemainAnalyticsLogCount() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Analytics", "getRemainAnalyticsLogCount");
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    picojson::value jsonValue = resJson.get("getRemainAnalyticsLogCount");
    if(jsonValue.is<picojson::null>())
        return 0;
    return static_cast<unsigned int>(jsonValue.get<double>());
}


void Analytics::executeEngine(picojson::value jsonParam)
{
	ResultAPI result;

}


NS_HIVE_END		// namespace hive



