//
//  HIVE_ProviderGoogle.cpp
//  Hive_v2_source
//
//  Created by sangpan on 2017. 9. 15..
//  Copyright © 2017년 GCP. All rights reserved.
//

#include "HIVE_CppPlugin.h"

NS_HIVE_BEGIN

static ProviderGoogle::onAchievementsResult g_ProviderGoogleShowAchievementListener;
static ProviderGoogle::onAchievementsResult g_ProviderGoogleAchievementsRevealListener;
static ProviderGoogle::onAchievementsResult g_ProviderGoogleAchievementsUnlockListener;
static ProviderGoogle::onAchievementsResult g_ProviderGoogleAchievementIncrementListener;

static ProviderGoogle::onLeaderboardsResult g_ProviderGoogleLeaderboardsSubmitScoreListener;
static ProviderGoogle::onLeaderboardsResult g_ProviderGoogleShowLeaderboardListener;

static ProviderGoogle::onGooglePlayerIdResult g_ProviderGoogleGetGooglePlayerIdListener;

void ProviderGoogle::achievementsReveal(const std::string achievementId)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsReveal");
    jsonParam["achievementId"] = picojson::value(achievementId);
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::achievementsReveal(const std::string achievementId, ProviderGoogle::onAchievementsResult listener)
{
    g_ProviderGoogleAchievementsRevealListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsReveal");
    jsonParam["achievementId"] = picojson::value(achievementId);
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::achievementsUnlock(const std::string achievementId)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsUnlock");
    jsonParam["achievementId"] = picojson::value(achievementId);
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::achievementsUnlock(const std::string achievementId, ProviderGoogle::onAchievementsResult listener)
{
    g_ProviderGoogleAchievementsUnlockListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsUnlock");
    jsonParam["achievementId"] = picojson::value(achievementId);
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::achievementsIncrement(const std::string incrementalAchievementId, const int argValue)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsIncrement");
    jsonParam["incrementalAchievementId"] = picojson::value(incrementalAchievementId);
    jsonParam["value"] = picojson::value(to_string(argValue));
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::achievementsIncrement(const std::string incrementalAchievementId, const int argValue, ProviderGoogle::onAchievementsResult listener)
{
    g_ProviderGoogleAchievementIncrementListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "achievementsIncrement");
    jsonParam["incrementalAchievementId"] = picojson::value(incrementalAchievementId);
    jsonParam["value"] = picojson::value(to_string(argValue));
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::leaderboardsSubmitScore(const std::string leaderboardId, const long long score)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "leaderboardsSubmitScore");
    jsonParam["leaderboardId"] = picojson::value(leaderboardId);
    jsonParam["score"] = picojson::value(to_string(score));
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::leaderboardsSubmitScore(const std::string leaderboardId, const long long score, ProviderGoogle::onLeaderboardsResult listener)
{
    g_ProviderGoogleLeaderboardsSubmitScoreListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "leaderboardsSubmitScore");
    jsonParam["leaderboardId"] = picojson::value(leaderboardId);
    jsonParam["score"] = picojson::value(to_string(score));
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::showLeaderboard(ProviderGoogle::onLeaderboardsResult listener)
{
    g_ProviderGoogleShowLeaderboardListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "showLeaderboards");
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::showAchievements(ProviderGoogle::onAchievementsResult listener)
{
    g_ProviderGoogleShowAchievementListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "showAchievements");
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::getGooglePlayerId(ProviderGoogle::onGooglePlayerIdResult listener)
{
    g_ProviderGoogleGetGooglePlayerIdListener = listener;
    picojson::object jsonParam = HiveCppPlugin::createParam("ProviderGoogle", "getGooglePlayerId");
    HiveCppPlugin::callNative(jsonParam);
}

void ProviderGoogle::executeEngine(picojson::value jsonParam)
{
    ResultAPI result(jsonParam.get("resultAPI"));

    std::string methodName = jsonParam.get("method").to_str();
    if (methodName.compare("showLeaderboards") == 0)
    {
        if (g_ProviderGoogleShowLeaderboardListener != NULL)
        {
            g_ProviderGoogleShowLeaderboardListener(result);
        }
    }else if (methodName.compare("achievementsReveal") == 0)
    {
        if (g_ProviderGoogleAchievementsRevealListener != NULL)
        {
            g_ProviderGoogleAchievementsRevealListener(result);
        }
    }else if (methodName.compare("achievementsUnlock") == 0)
    {
        if (g_ProviderGoogleAchievementsUnlockListener != NULL)
        {
            g_ProviderGoogleAchievementsUnlockListener(result);
        }
    }else if (methodName.compare("achievementsIncrement") == 0)
    {
        if (g_ProviderGoogleAchievementIncrementListener != NULL)
        {
            g_ProviderGoogleAchievementIncrementListener(result);
        }
    }else if (methodName.compare("showAchievements") == 0)
    {
        if (g_ProviderGoogleShowAchievementListener != NULL)
        {
            g_ProviderGoogleShowAchievementListener(result);
        }
    }
    else if (methodName.compare("leaderboardsSubmitScore") == 0)
    {
        if (g_ProviderGoogleLeaderboardsSubmitScoreListener != NULL)
        {
            g_ProviderGoogleLeaderboardsSubmitScoreListener(result);
        }
    }
    else if (methodName.compare("getGooglePlayerId") == 0)
    {
        if (g_ProviderGoogleGetGooglePlayerIdListener != NULL)
        {
            g_ProviderGoogleGetGooglePlayerIdListener(result, jsonParam.get("googlePlayerId").to_str(), jsonParam.get("authCode").to_str());
        }
    }
}
NS_HIVE_END
