


#include "HIVE_CppPlugin.h"


NS_HIVE_BEGIN


static SocialGoogle::onProfileGoogle g_onProfileGoogle = NULL;


void SocialGoogle::getMyProfile(onProfileGoogle listener)
{
	g_onProfileGoogle = listener;


	picojson::object jsonParam = HiveCppPlugin::createParam("SocialGoogle", "getMyProfile");

	HiveCppPlugin::callNative(jsonParam);
}




void SocialGoogle::executeEngine(picojson::value jsonParam)
{
	ResultAPI result(jsonParam.get("resultAPI"));

	std::string methodName = jsonParam.get("method").to_str();
	if(methodName.compare("getMyProfile") == 0)
	{
		if(g_onProfileGoogle != NULL)
		{
			picojson::value jsonValue;

            std::vector<ProfileGooglePlay> profileList;

            jsonValue = jsonParam.get("profileList");
            if(jsonValue.is<picojson::null>() || jsonValue.is<picojson::array>() == false) {
            	profileList.push_back(ProfileGooglePlay());
            }
            else
            {
            	picojson::array profileListJson = jsonValue.get<picojson::array>();
				for (picojson::array::iterator iter = profileListJson.begin(); iter != profileListJson.end(); ++iter)
				{
					ProfileGooglePlay profileFacebook((*iter));
					profileList.push_back(profileFacebook);
				}
            }
            
            g_onProfileGoogle(result, profileList);
		}

	}
}




// ProfileGooglePlay class Implements
SocialGoogle::ProfileGooglePlay::ProfileGooglePlay()
{
}


SocialGoogle::ProfileGooglePlay::ProfileGooglePlay(std::string arg_playerId, std::string arg_playerName)
{
	this->playerId = arg_playerId;
	this->playerName = arg_playerName;
}


SocialGoogle::ProfileGooglePlay::ProfileGooglePlay(picojson::value jsonParam)
{
    if(jsonParam.is<picojson::null>())
        return;

    picojson::value jsonValue;
    
    jsonValue = jsonParam.get("playerId");
    if(jsonValue.is<picojson::null>() == false)
        this->playerId = jsonValue.to_str();
    
    jsonValue = jsonParam.get("playerName");
    if(jsonValue.is<picojson::null>() == false)
        this->playerName = jsonValue.to_str();
}


picojson::object SocialGoogle::ProfileGooglePlay::toJson() const
{
	picojson::object resJson;
	resJson["playerId"] = picojson::value(this->playerId);
	resJson["playerName"] = picojson::value(this->playerName);
	return resJson;
}


std::string SocialGoogle::ProfileGooglePlay::toString() const
{
	picojson::object resJson = this->toJson();
	std::string resJsonString = picojson::value(resJson).serialize();
	return resJsonString;

}


NS_HIVE_END		// namespace hive



