package com.hive.sample;


import java.util.ArrayList;
import java.util.Locale;

import android.app.Activity;
import android.content.DialogInterface;
import android.content.DialogInterface.OnDismissListener;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.hive.Promotion;
import com.hive.Promotion.AppInvitationData;
import com.hive.Promotion.PromotionBadge;
import com.hive.Promotion.PromotionCustomType;
import com.hive.Promotion.PromotionViewInfo;
import com.hive.Promotion.PromotionViewType;
import com.hive.Promotion.PromotionBadgeInfoListener;
import com.hive.Promotion.PromotionViewInfoListener;
import com.hive.Promotion.AppInvitationDataListener;

import com.com2us.hivesdk.normal.freefull.google.global.android.common.R;


import com.hive.ResultAPI;

import com.hive.sample.uihelper.ViewPagerBase;




/**
 * HIVE SDK 의 Promotion 기능 테스트 뷰
 * 
 * @author ryuvsken
 */
public class PromotionTestView extends ViewPagerBase implements View.OnClickListener {
	
	
	public PromotionTestView(Activity activity, View view, String title) {
		super(activity, view, title);

		initUi();
	}

	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	private void initUi() {

		createLogView(R.id.logview, R.id.btnLogDialog, R.id.btnLogClear);
		
		ArrayAdapter spAdapter;
		Spinner spinner;

		//ViewType
		spAdapter = new ArrayAdapter(activity, android.R.layout.simple_spinner_item);
		spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spAdapter.add("news");
		spAdapter.add("notice");
		spAdapter.add("banner");
		spAdapter.add("bannerlegacy");
		spAdapter.add("spot");
		spAdapter.add("board");
		spAdapter.add("view");
		spAdapter.add("direct");

		spinner = (Spinner)this.view.findViewById(R.id.spPromotionViewType);
		spinner.setAdapter(spAdapter);

		//CampaignType
		spAdapter = new ArrayAdapter(activity, android.R.layout.simple_spinner_item);
		spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spAdapter.add("event");
		spAdapter.add("notice");

		spinner = (Spinner)this.view.findViewById(R.id.spPromotionCampaignType);
		spinner.setAdapter(spAdapter);

		//BannerType
		spAdapter = new ArrayAdapter(activity, android.R.layout.simple_spinner_item);
		spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spAdapter.add("rolling");
		spAdapter.add("great");
		spAdapter.add("small");

		spinner = (Spinner)this.view.findViewById(R.id.spPromotionBannerType);
		spinner.setAdapter(spAdapter);

		//isForced
		spAdapter = new ArrayAdapter(activity, android.R.layout.simple_spinner_item);
		spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spAdapter.add("false");
		spAdapter.add("true");

		spinner = (Spinner)this.view.findViewById(R.id.spIsForced);
		spinner.setAdapter(spAdapter);


		this.view.findViewById(R.id.btnPromotionGetOfferwallState).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowPromotion).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowCustomContents).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowOfferwall).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowReview).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowNativeReview).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionExit).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionGetViewInfo).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionGetBadgeInfo).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionGetBannerInfo).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionGetAppInvitationData).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionSetAdditionalInfo).setOnClickListener(this);
		this.view.findViewById(R.id.btnPromotionShowEngagementTestPage).setOnClickListener(this);
	}


	// 프로모션 뷰의 결과 통지 리스너 - Promotion.showPromotion()
	private com.hive.Promotion.PromotionViewListener promotionViewListener = new com.hive.Promotion.PromotionViewListener() {

        @Override
        public void onPromotionView(ResultAPI result, Promotion.PromotionViewResultType type) {

            switch (type) {
                case OPENED:
                    addLog(String.format("PromotionViewListener.onPromotionView() Callback\nresult = %s\ntype = %s\n", result.toString(), type.toString()));
                    break;
                case CLOSED:
                    addLog(String.format("PromotionViewListener.onPromotionView() Callback\nresult = %s\ntype = %s\n", result.toString(), type.toString()));
                    break;
				case START_PLAYBACK:
					addLog(String.format("PromotionViewListener.onPromotionView() Callback\nresult = %s\ntype = %s\n", result.toString(), type.toString()));
					Toast.makeText(activity, "광고 영상 시작됨.\n게임 볼륨(배경음, 효과음 등) 줄이기",Toast.LENGTH_SHORT).show();
					break;
				case FINISH_PLAYBACK:
					addLog(String.format("PromotionViewListener.onPromotionView() Callback\nresult = %s\ntype = %s\n", result.toString(), type.toString()));
					Toast.makeText(activity, "광고 영상 종료됨.\n게임 볼륨(배경음, 효과음 등) 원래대로 복구",Toast.LENGTH_SHORT).show();
					break;
				case NEED_TO_EXIT:
                    addLog(String.format("PromotionViewListener.onPromotionView() Callback\nresult = %s\ntype = %s\n", result.toString(), type.toString()));
                    break;
            }
        }
	};
	
	
    private PromotionViewInfoListener promotionViewInfoListener = new PromotionViewInfoListener() {

        @Override
        public void onReceiveInfo(ResultAPI result, ArrayList<PromotionViewInfo> infos) {

            StringBuffer sb = new StringBuffer();

			if (result.isSuccess() && infos != null) {

				sb.append("[");
				for (PromotionViewInfo promotionViewInfo : infos) {
					sb.append("{" + promotionViewInfo.toString() + "}");
				}
				sb.append("]");
			}

            addLog(String.format("PromotionInfoListener.onViewInfoReceive() Callback\nresult = %s\nviewInfo = %s\n"
                    , result.toString(), sb.toString()));
        }
    };


    private PromotionBadgeInfoListener promotionBadgeInfoListener = new PromotionBadgeInfoListener() {

        @Override
        public void onReceiveInfo(ResultAPI result, ArrayList<PromotionBadge> infos) {

            StringBuffer sb = new StringBuffer();

			if (result.isSuccess() && infos != null) {

				for (PromotionBadge promotionBadge : infos) {

					sb.append("[ " + promotionBadge.toString() + "] ");
				}
				sb.append("\n");
			}

            addLog(String.format("PromotionInfoListener.onViewInfoReceived() Callback\nresult = %s\npromotionBadges = %s"
                    , result.toString(), sb.toString()));
        }
    };


	private Promotion.PromotionBannerInfoListener promotionBannerInfoListener = new Promotion.PromotionBannerInfoListener() {
		@Override
		public void onReceiveInfo(ResultAPI result, ArrayList<Promotion.PromotionBanner> bannerInfoList) {

			addLog("PromotionBannerInfoListener.onReceiveInfo() Callback\nresult = " + result);

			StringBuffer sb = new StringBuffer();

			if (result.isSuccess() && bannerInfoList != null) {

				for (Promotion.PromotionBanner promotionBanner : bannerInfoList) {

					sb.append("[ " + promotionBanner.toString() + "] ");
				}
				sb.append("\n");

				addLog("\nbanners = " + sb.toString());

				PromotionBannerDialog promotionBannerDialog = new PromotionBannerDialog(activity, bannerInfoList, PromotionTestView.this);
				promotionBannerDialog.show();


			} else {

				showAlertDialog("Promotion getBannerInfo Failed", result.toString());
			}
		}
	};

	
	private AppInvitationDataListener appInvitationDataListener = new AppInvitationDataListener() {
		
		@Override
		public void onAppInvitationData(ResultAPI result, AppInvitationData info) {

			addLog(String.format("AppInvitationDataListener.onAppInvitationData() Callback\nresult = %s\nappInvitationData = %s\n"
				, result.toString(), info!=null?info.toString():"null"));
			
			if(result.isSuccess()) {
				
				PromotionAppInvitationDataDialog appInvitationDataView = new PromotionAppInvitationDataDialog(activity, info);
				appInvitationDataView.setOnDismissListener(new OnDismissListener() {
					
					@Override
					public void onDismiss(DialogInterface dialog) {
						// not used.
					}
				});
				
				appInvitationDataView.show();
			}
			
		}
	};
	
	
	@Override
	public void onClick(View v) {

		int rid = v.getId();

		switch(rid) {
		
			case R.id.btnPromotionShowPromotion: {
				
				Spinner spinner = (Spinner)this.view.findViewById(R.id.spPromotionViewType);
				String selectedValue = (String) spinner.getAdapter().getItem(spinner.getSelectedItemPosition());
				if (PromotionViewType.get(selectedValue) == null) {
					return; 
				}
				
				PromotionViewType promotionViewType = PromotionViewType.valueOf(selectedValue.toUpperCase(Locale.US));
				
				spinner = (Spinner)this.view.findViewById(R.id.spIsForced); 
				String selectedIsForced = (String) spinner.getAdapter().getItem(spinner.getSelectedItemPosition());
				
				
				addLog("\n\n=== 이벤트, 프로모션 화면 노출. ===\n");
				addLog(String.format("Promotion.showPromotion(promotionType = %s, isForced = %s, listener) Called\n"
						, promotionViewType.name(), selectedIsForced));
				
				Promotion.showPromotion(promotionViewType, Boolean.valueOf(selectedIsForced), promotionViewListener);
				
			}
			break;
			
			
			case R.id.btnPromotionShowCustomContents: {
				
				Spinner spinner = (Spinner)this.view.findViewById(R.id.spPromotionViewType);
				String selectedValue = (String) spinner.getAdapter().getItem(spinner.getSelectedItemPosition());
				if (PromotionCustomType.get(selectedValue) == null) {
					return;
				}
				
				PromotionCustomType promotionCustomType = PromotionCustomType.valueOf(selectedValue.toUpperCase(Locale.US));
				
				EditText editText = (EditText)this.view.findViewById(R.id.edtContentKey);
				String content_key = editText.getText().toString();

				
				addLog("\n\n=== Custom 웹뷰 화면 노출. ===\n");
				addLog(String.format("Promotion.showCustomView(%s, listener) Called\n", content_key));
				
				Promotion.showCustomContents(promotionCustomType, content_key, promotionViewListener);
			}
			break;
			
			
			case R.id.btnPromotionGetOfferwallState: {
			
				Promotion.OfferwallState offerwallState = Promotion.getOfferwallState();
				
				addLog("\n\n=== 게임내 오퍼월(무료 충전소) 노출 가능 여부 조회 (Android only) ===\n");
				addLog(String.format("Promotion.getOfferwallState() Called\nofferwallState = %s\n", offerwallState.name()));
				
			}
			break;
			
			
			case R.id.btnPromotionShowOfferwall: {
				
				addLog("\n\n=== 게임내 오퍼월(무료 충전소) 화면 노출. (Android only) ===\n");
				addLog("Promotion.showOfferwall(listener) Called\n");
				
				Promotion.showOfferwall(promotionViewListener);
			}
			break;

			case R.id.btnPromotionShowNativeReview: {


				addLog("\n\n=== 게임 리뷰 팝업 대화 상자 노출. (HIVE SDK 4.10.0+) ===\n");
				addLog("Promotion.showNativeReview() Called\n");

				Promotion.showNativeReview();
			}
			break;

			case R.id.btnPromotionExit: {
				
				addLog("\n\n=== 게임 종료 대화 상자 노출 (Android only) ===\n");
				addLog("Promotion.showExit(listener) Called\n");
				
				Promotion.showExit(promotionViewListener);
			}
			break;
			
			
			case R.id.btnPromotionGetViewInfo: {
				
				Spinner spinner = (Spinner)this.view.findViewById(R.id.spPromotionViewType);
				String selectedValue = (String) spinner.getAdapter().getItem(spinner.getSelectedItemPosition());
				
				if (PromotionCustomType.get(selectedValue) == null) {
					return;
				}
				
				PromotionCustomType promotionCustomType = PromotionCustomType.valueOf(selectedValue.toUpperCase(Locale.US));
				
				EditText editText = (EditText)this.view.findViewById(R.id.edtContentKey);
				String content_key = editText.getText().toString();
				
				addLog("\n\n=== viewId에 해당하는 프로모션 컨텐츠 조회. ===\n");
				addLog(String.format("Promotion.getViewInfo(viewId = %s, listener) Called\n", content_key));

				Promotion.getViewInfo(promotionCustomType, content_key, promotionViewInfoListener);
			}
			break;
			
			
			case R.id.btnPromotionGetBadgeInfo: {
				
				addLog("\n\n=== 게임내 프로모션 버튼의 부각을 위한 정보 (Badge) 조회 ===\n");
				addLog("Promotion.getBadgeInfo(listener) Called\n");
				
				Promotion.getBadgeInfo(promotionBadgeInfoListener);
			}
			break;


			case R.id.btnPromotionGetBannerInfo: {

				Spinner campaignTypeSpinner = (Spinner)this.view.findViewById(R.id.spPromotionCampaignType);
				String selectedCampaignValue = (String) campaignTypeSpinner.getAdapter().getItem(campaignTypeSpinner.getSelectedItemPosition());

				if (Promotion.PromotionCampaignType.get(selectedCampaignValue) == null) {
					addLog("Promotion.getBannerInfo(listener) CampaignType is null\n");
					return;
				}

				Spinner bannerTypeSpinner = (Spinner)this.view.findViewById(R.id.spPromotionBannerType);
				String selectedBannerValue = (String) bannerTypeSpinner.getAdapter().getItem(bannerTypeSpinner.getSelectedItemPosition());

				if (Promotion.PromotionBannerType.get(selectedBannerValue) == null) {
					addLog("Promotion.getBannerInfo(listener) BannerType is null\n");
					return;
				}

				Promotion.PromotionCampaignType promotionCampaignType = Promotion.PromotionCampaignType.valueOf(selectedCampaignValue.toUpperCase(Locale.US));
				Promotion.PromotionBannerType promotionBannerType = Promotion.PromotionBannerType.valueOf(selectedBannerValue.toUpperCase(Locale.US));

				addLog("\n\n=== 롤링 프로모션 배너 정보 조회 (Banner) 조회 ===\n");
				addLog("Promotion.getBannerInfo(listener) Called\n");

				Promotion.getBannerInfo(promotionCampaignType, promotionBannerType, promotionBannerInfoListener);
			}
			break;
			
			
			case R.id.btnPromotionGetAppInvitationData: {
				
				addLog("\n\n=== 앱 초대를 위한 데이터 조회 (qrCode, inviteLink) ===\n");
				addLog("Promotion.getAppInvitationData(listener) Called\n");
				
				Promotion.getAppInvitationData(appInvitationDataListener);
			}
			break;
			
			
			case R.id.btnPromotionSetAdditionalInfo: {
				
				EditText editText = (EditText)this.view.findViewById(R.id.edtAdditionalInfo);
				String additionalInfo = editText.getText().toString();
				
				addLog("\n\n=== GMS 등을 통해 별도의 가공 없이 게임 서버 API 또는 게임 서버의 중계용 API 등 그에 준하는 API에 전달될 값 설정 ===\n");
				addLog(String.format("Promotion.setAdditionalInfo(additionalInfo = %s) Called\n", additionalInfo));
				
				Promotion.setAdditionalInfo(additionalInfo);
			}
			break;
			
			case R.id.btnPromotionShowEngagementTestPage: {
				
				String viewId = "310000";
				
				addLog("\n\n=== EngagementTestPage 노출. ===\n");
				addLog(String.format("Promotion.showCustomView(%s, listener) Called\n", viewId));
				
				Promotion.showCustomContents(PromotionCustomType.VIEW, viewId, promotionViewListener);
			}
			break;
			
			
		}
	}
}



