package com.hive.sample.game;

import android.text.TextUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.Serializable;

public class Post implements PostBoxObject, Serializable {

	protected String postId;
	public String assetCode;
	public int assetAmount;
	public String userMsg;
	public String characterKey;
	public String dateAdded;
	
	public JSONObject originalJson;

	public Post(String postId, String assetCode, int assetAmount, String userMsg, String characterKey, String dateAdded) {
		this.postId = postId;
		this.assetCode = assetCode;
		this.assetAmount = assetAmount;
		this.userMsg = userMsg;
		this.characterKey = characterKey;
		this.dateAdded = dateAdded;
	}

	public Post(JSONObject postData) throws JSONException {
		
		if(postData == null) 
			throw new JSONException("post data is null");
		
		originalJson = postData;
		
		postId = originalJson.getString("post_id");
		assetCode = originalJson.optString("asset_code");
		assetAmount = originalJson.optInt("asset_amount");
		userMsg = originalJson.optString("user_msg");
		characterKey = originalJson.optString("character_key");
		dateAdded = originalJson.optString("date_added");
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Post) {

			Post input = (Post)obj;

			if ( TextUtils.equals(postId, input.postId) )
				return true;

			else return false;

		} else {
			return false;
		}
	}

	@Override
	public String toString() {
		return originalJson.toString();
	}

	@Override
	public String getPostId() {
		return postId;
	}

	@Override
	public String getMarketPid() {
		return null;
	}

	@Override
	public String getAssetCode() {
		return assetCode;
	}

	@Override
	public String getAssetAmount() {
		return String.valueOf(assetAmount/10);
	}

	@Override
	public String getCharaterKey() {
		return characterKey;
	}

	@Override
	public String getDate() {
		return dateAdded;
	}

	@Override
	public String getUserMsg() {
		return userMsg;
	}
}
