package com.hive.sample.game;

import android.util.TimeUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class PostSubscription implements PostBoxObject, Serializable {


    protected String  product_id;     /// 재화 코드
    int     market_id;      /// 구독 구매 마켓 , 1 : 애플 , 2: 구글
    String  start_date;     /// 구독 시작시간(KST)
    Long    start_date_ms;  /// 구독 시작시간 unix timestamp
    String  expire_date;    /// 구독 만료시간(KST)
    Long    expire_date_ms; /// 구독 만료시간 unix timestamp
    String  character_key;  /// 캐릭터 키

    public JSONObject originalJson;

    public PostSubscription() {
        super();
    }

    public PostSubscription(JSONObject postData) throws JSONException {

        if(postData == null)
            throw new JSONException("post data is null");

        originalJson = postData;

        product_id = originalJson.getString("product_id");
        market_id = originalJson.optInt("market_id");
        start_date = originalJson.getString("start_date");
        start_date_ms = originalJson.optLong("start_date_ms");
        expire_date = originalJson.optString("expire_date");
        expire_date_ms = originalJson.optLong("expire_date_ms");
        character_key = originalJson.optString("character_key");
    }

    @Override
    public int hashCode() {
        return super.hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        return super.equals(obj);
    }

    @Override
    public String toString() {
        return super.toString();
    }

    @Override
    protected void finalize() throws Throwable {
        super.finalize();
    }

    @Override
    public String getPostId() {
        return null;
    }

    @Override
    public String getMarketPid() {
        return product_id;
    }

    @Override
    public String getAssetCode() {
        return "구독";
    }

    @Override
    public String getAssetAmount() {
        long remainTime = expire_date_ms - System.currentTimeMillis();

        int seconds = (int) (remainTime / 1000) % 60;
        int minutes =  ((int)(remainTime / 1000) / 60) % 60;
        int hours = (int)(remainTime / 1000) / 3600;
        String result = String.format("ETA %02d:%02d:%02d",hours,minutes,seconds);
        return result;
    }

    @Override
    public String getCharaterKey() {
        return character_key;
    }

    @Override
    public String getDate() {
        return start_date+"~\n"+expire_date;
    }

    @Override
    public String getUserMsg() {
        return (market_id == 1 ? "Apple" : "Google")+":"+product_id;
    }
}
